var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import gql from 'graphql-tag';
import { Logger, Plugin, Proposal, SchemeRegistrar } from '../../index';
var SchemeRegistrarProposal = /** @class */ (function (_super) {
    __extends(SchemeRegistrarProposal, _super);
    function SchemeRegistrarProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SchemeRegistrarProposal, "fragment", {
        get: function () {
            if (!this.fragmentField) {
                this.fragmentField = {
                    name: 'SchemeRegistrarProposalFields',
                    fragment: gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          fragment SchemeRegistrarProposalFields on Proposal {\n            schemeRegistrar {\n              id\n              schemeToRegister\n              schemeToRegisterPermission\n              schemeToRemove\n              decision\n              schemeRegistered\n              schemeRemoved\n            }\n          }\n        "], ["\n          fragment SchemeRegistrarProposalFields on Proposal {\n            schemeRegistrar {\n              id\n              schemeToRegister\n              schemeToRegisterPermission\n              schemeToRemove\n              decision\n              schemeRegistered\n              schemeRemoved\n            }\n          }\n        "])))
                };
            }
            return this.fragmentField;
        },
        enumerable: true,
        configurable: true
    });
    SchemeRegistrarProposal.itemMap = function (context, item, query) {
        var _a;
        if (!item) {
            Logger.debug("SchemeRegistrar Proposal ItemMap failed. Query: " + ((_a = query.loc) === null || _a === void 0 ? void 0 : _a.source.body));
            return null;
        }
        var type;
        if (item.schemeRegistrar.schemeToRegister) {
            // TODO: this is failing bc of https://github.com/daostack/subgraph/issues/224
            if (item.dao.schemes
                .map(function (s) { return s.address.toLowerCase(); })
                .includes(item.schemeRegistrar.schemeToRegister.toLowerCase())) {
                type = 'SchemeRegistrarEdit';
            }
            else {
                type = 'SchemeRegistrarAdd';
            }
        }
        else if (item.schemeRegistrar.schemeToRemove) {
            type = 'SchemeRegistrarRemove';
        }
        else {
            throw Error("Unknown proposal type: schemeRegistrar without a scheme to register or to remove");
        }
        var schemeRegistrarState = SchemeRegistrar.itemMap(context, item.scheme, query);
        if (!schemeRegistrarState) {
            return null;
        }
        var schemeRegistrar = new SchemeRegistrar(context, schemeRegistrarState);
        var schemeRegistrarProposal = new SchemeRegistrarProposal(context, item.id);
        var baseState = Proposal.itemMapToBaseState(context, item, schemeRegistrar, schemeRegistrarProposal, type);
        if (!baseState) {
            return null;
        }
        return __assign(__assign({}, baseState), { decision: item.schemeRegistrar.decision, schemeRegistered: item.schemeRegistrar.schemeRegistered, schemeRemoved: item.schemeRegistrar.schemeRemoved, schemeToRegister: item.schemeRegistrar.schemeToRegister, schemeToRegisterPermission: item.schemeRegistrar.schemeToRegisterPermission, schemeToRemove: item.schemeRegistrar.schemeToRemove });
    };
    SchemeRegistrarProposal.prototype.state = function (apolloQueryOptions) {
        var query = gql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, Proposal.baseFragment, Plugin.baseFragment);
        return this.context.getObservableObject(this.context, query, SchemeRegistrarProposal.itemMap, apolloQueryOptions);
    };
    return SchemeRegistrarProposal;
}(Proposal));
export { SchemeRegistrarProposal };
var templateObject_1, templateObject_2;
//# sourceMappingURL=proposal.js.map