var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import gql from 'graphql-tag';
import { DAO, Logger, Plugin } from '../index';
var UnknownPlugin = /** @class */ (function (_super) {
    __extends(UnknownPlugin, _super);
    function UnknownPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UnknownPlugin.itemMap = function (context, item, query) {
        var _a;
        if (!item) {
            Logger.debug("Uknown Plugin ItemMap failed. Query: " + ((_a = query.loc) === null || _a === void 0 ? void 0 : _a.source.body));
            return null;
        }
        var name = item.name;
        if (!name) {
            try {
                name = context.getContractInfo(item.address).name;
            }
            catch (err) {
                if (err.message.match(/no contract/gi)) {
                    // continue
                }
                else {
                    throw err;
                }
            }
        }
        return {
            address: item.address,
            canDelegateCall: item.canDelegateCall,
            canManageGlobalConstraints: item.canManageGlobalConstraints,
            canRegisterPlugins: item.canRegisterSchemes,
            canUpgradeController: item.canUpgradeController,
            dao: {
                id: item.dao.id,
                entity: new DAO(context, item.dao.id)
            },
            id: item.id,
            name: name,
            numberOfBoostedProposals: Number(item.numberOfBoostedProposals),
            numberOfPreBoostedProposals: Number(item.numberOfPreBoostedProposals),
            numberOfQueuedProposals: Number(item.numberOfQueuedProposals),
            version: item.version
        };
    };
    UnknownPlugin.prototype.state = function (apolloQueryOptions) {
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        var query = gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query SchemeStateById\n      {\n        controllerScheme (id: \"", "\") {\n          ...PluginFields\n        }\n      }\n      ", "\n    "], ["query SchemeStateById\n      {\n        controllerScheme (id: \"", "\") {\n          ...PluginFields\n        }\n      }\n      ", "\n    "])), this.id, Plugin.baseFragment);
        return this.context.getObservableObject(this.context, query, UnknownPlugin.itemMap, apolloQueryOptions);
    };
    return UnknownPlugin;
}(Plugin));
export { UnknownPlugin };
var templateObject_1;
//# sourceMappingURL=unknownPlugin.js.map