var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import BN from 'bn.js';
import gql from 'graphql-tag';
import { createGraphQlQuery, DAO, Entity, isAddress, Plugin, Plugins, realMathToNumber } from './index';
var Queue = /** @class */ (function (_super) {
    __extends(Queue, _super);
    function Queue(context, idOrOpts, dao) {
        var _this = _super.call(this, context, idOrOpts) || this;
        _this.dao = dao;
        _this.context = context;
        if (typeof idOrOpts === 'string') {
            _this.id = idOrOpts;
        }
        else {
            _this.id = idOrOpts.id;
            _this.setState(idOrOpts);
        }
        return _this;
    }
    Queue.search = function (context, options, apolloQueryOptions) {
        if (options === void 0) { options = {}; }
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        if (!options.where) {
            options.where = {};
        }
        var where = '';
        for (var _i = 0, _a = Object.keys(options.where); _i < _a.length; _i++) {
            var key = _a[_i];
            if (options[key] === undefined) {
                continue;
            }
            if (key === 'dao' || key === 'votingMaching' || key === 'scheme') {
                var option = options[key];
                isAddress(option);
                options[key] = option.toLowerCase();
            }
            where += key + ": \"" + options[key] + "\"\n";
        }
        // use the following query once https://github.com/daostack/subgraph/issues/217 is resolved
        var query = gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query QueueSearch\n      {\n        gpqueues ", " {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...PluginFields\n          }\n        }\n      }\n\n      ", "\n    "], ["query QueueSearch\n      {\n        gpqueues ", " {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...PluginFields\n          }\n        }\n      }\n\n      ", "\n    "])), createGraphQlQuery(options, where), Plugin.baseFragment);
        var itemMap = function (arc, item, queryDoc) {
            return new Queue(arc, item.id, new DAO(arc, item.dao.id));
        };
        return context.getObservableList(context, query, itemMap, apolloQueryOptions);
    };
    Queue.itemMap = function (context, item, query) {
        var _a;
        if (!item) {
            throw Error("Queue ItemMap failed. Query: " + ((_a = query.loc) === null || _a === void 0 ? void 0 : _a.source.body));
        }
        var threshold = realMathToNumber(new BN(item.threshold));
        var pluginState = Plugins[item.scheme.name].itemMap(context, item.scheme, query);
        if (!pluginState) {
            throw new Error('Queue\'s plugin state is null');
        }
        var plugin = new Plugins[item.scheme.name](context, pluginState);
        var dao = new DAO(context, item.dao.id);
        return {
            dao: {
                id: dao.id,
                entity: dao
            },
            id: item.id,
            name: item.scheme.name,
            plugin: {
                id: item.scheme.id,
                entity: plugin
            },
            threshold: threshold,
            votingMachine: item.votingMachine
        };
    };
    Queue.prototype.state = function (apolloQueryOptions) {
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        var query = gql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["query QueueState\n      {\n        gpqueue (id: \"", "\") {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...PluginFields\n          }\n          votingMachine\n          threshold\n        }\n      }\n      ", "\n    "], ["query QueueState\n      {\n        gpqueue (id: \"", "\") {\n          id\n          dao {\n            id\n          }\n          scheme {\n            ...PluginFields\n          }\n          votingMachine\n          threshold\n        }\n      }\n      ", "\n    "])), this.id, Plugin.baseFragment);
        return this.context.getObservableObject(this.context, query, Queue.itemMap, apolloQueryOptions);
    };
    return Queue;
}(Entity));
export { Queue };
var templateObject_1, templateObject_2;
//# sourceMappingURL=queue.js.map