var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import BN from 'bn.js';
import gql from 'graphql-tag';
import { createGraphQlQuery, Entity, IProposalOutcome, isAddress, Proposals } from './index';
var Stake = /** @class */ (function (_super) {
    __extends(Stake, _super);
    function Stake() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Stake.search = function (context, options, apolloQueryOptions) {
        if (options === void 0) { options = {}; }
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        if (!options.where) {
            options.where = {};
        }
        var where = '';
        var itemMap = function (arc, item, queryDoc) {
            var state = Stake.itemMap(arc, item, queryDoc);
            return new Stake(arc, state);
        };
        var proposalId = options.where.proposal;
        // if we are searching for stakes on a specific proposal (a common case), we
        // will structure the query so that stakes are stored in the cache together wit the proposal
        if (proposalId) {
            delete options.where.proposal;
        }
        for (var _i = 0, _a = Object.keys(options.where); _i < _a.length; _i++) {
            var key = _a[_i];
            if (options.where[key] === undefined) {
                continue;
            }
            if (key === 'staker' || key === 'dao') {
                var option = options.where[key];
                isAddress(option);
                options.where[key] = option.toLowerCase();
            }
            where += key + ": \"" + options.where[key] + "\"\n";
        }
        var query;
        if (proposalId && !options.where.id) {
            query = gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalStakesSearchFromProposal\n        {\n          proposal (id: \"", "\") {\n            id\n            scheme {\n              id\n              name\n            }\n            stakes ", " {\n              ...StakeFields\n            }\n          }\n        }\n        ", "\n      "], ["query ProposalStakesSearchFromProposal\n        {\n          proposal (id: \"", "\") {\n            id\n            scheme {\n              id\n              name\n            }\n            stakes ", " {\n              ...StakeFields\n            }\n          }\n        }\n        ", "\n      "])), proposalId, createGraphQlQuery(options, where), Stake.fragments.StakeFields);
            return context.getObservableObject(context, query, function (arc, r, queryDoc) {
                if (!r) {
                    // no such proposal was found
                    return [];
                }
                var stakes = r.stakes;
                var itemMapper = function (item) {
                    var state = Stake.itemMap(arc, item, queryDoc);
                    return new Stake(arc, state);
                };
                if (!stakes) {
                    return [];
                }
                return stakes.map(itemMapper);
            }, apolloQueryOptions);
        }
        else {
            query = gql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["query ProposalStakesSearch\n        {\n          proposalStakes ", " {\n              ...StakeFields\n          }\n        }\n        ", "\n      "], ["query ProposalStakesSearch\n        {\n          proposalStakes ", " {\n              ...StakeFields\n          }\n        }\n        ", "\n      "])), createGraphQlQuery(options, where), Stake.fragments.StakeFields);
            return context.getObservableList(context, query, itemMap, apolloQueryOptions);
        }
    };
    Stake.prototype.state = function (apolloQueryOptions) {
        if (apolloQueryOptions === void 0) { apolloQueryOptions = {}; }
        var query = gql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["query StakeState\n      {\n        proposalStake (id: \"", "\") {\n          id\n          createdAt\n          staker\n          proposal {\n            id\n          }\n          outcome\n          amount\n        }\n      }\n    "], ["query StakeState\n      {\n        proposalStake (id: \"", "\") {\n          id\n          createdAt\n          staker\n          proposal {\n            id\n          }\n          outcome\n          amount\n        }\n      }\n    "])), this.id);
        return this.context.getObservableObject(this.context, query, Stake.itemMap, apolloQueryOptions);
    };
    Stake.fragments = {
        StakeFields: gql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n      fragment StakeFields on ProposalStake {\n        id\n        createdAt\n        dao {\n          id\n        }\n        staker\n        proposal {\n          id\n          scheme {\n            id\n            name\n          }\n        }\n        outcome\n        amount\n      }\n    "], ["\n      fragment StakeFields on ProposalStake {\n        id\n        createdAt\n        dao {\n          id\n        }\n        staker\n        proposal {\n          id\n          scheme {\n            id\n            name\n          }\n        }\n        outcome\n        amount\n      }\n    "])))
    };
    Stake.itemMap = function (context, item, query) {
        var _a;
        if (!item) {
            throw Error("Stake ItemMap failed. Query: " + ((_a = query.loc) === null || _a === void 0 ? void 0 : _a.source.body));
        }
        var outcome = IProposalOutcome.Pass;
        if (item.outcome === 'Pass') {
            outcome = IProposalOutcome.Pass;
        }
        else if (item.outcome === 'Fail') {
            outcome = IProposalOutcome.Fail;
        }
        else {
            throw new Error("Unexpected value for proposalStakes.outcome: " + item.outcome);
        }
        return {
            amount: new BN(item.amount),
            createdAt: item.createdAt,
            id: item.id,
            outcome: outcome,
            proposal: {
                id: item.proposal.id,
                entity: new Proposals[item.proposal.scheme.name](context, item.proposal.id)
            },
            staker: item.staker
        };
    };
    return Stake;
}(Entity));
export { Stake };
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=stake.js.map