import BN from 'bn.js';
import { DocumentNode } from 'graphql';
import { Address, Arc, IContributionRewardProposalState, IGenesisProtocolParams, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionResultHandler } from '../../index';
export interface IContributionRewardState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
    };
}
export interface IProposalCreateOptionsCR extends IProposalBaseCreateOptions {
    beneficiary: Address;
    nativeTokenReward?: BN;
    reputationReward?: BN;
    ethReward?: BN;
    externalTokenReward?: BN;
    externalTokenAddress?: Address;
    periodLength?: number;
    periods?: any;
}
export declare class ContributionReward extends ProposalPlugin<IContributionRewardState, IContributionRewardProposalState, IProposalCreateOptionsCR> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query: DocumentNode): IContributionRewardState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsCR): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
}
