import BN from 'bn.js';
import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { Address, Arc, ContributionRewardExtProposal, IContributionRewardExtProposalState, IGenesisProtocolParams, IPluginState, IProposalBaseCreateOptions, ITransaction, ITransactionReceipt, ProposalPlugin } from '../../index';
export interface IContributionRewardExtState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteParams: IGenesisProtocolParams;
        rewarder: Address;
    };
}
export interface IProposalCreateOptionsCRExt extends IProposalBaseCreateOptions {
    beneficiary: Address;
    nativeTokenReward?: BN;
    reputationReward?: BN;
    ethReward?: BN;
    externalTokenReward?: BN;
    externalTokenAddress?: Address;
    proposer: Address;
}
export declare class ContributionRewardExt extends ProposalPlugin<IContributionRewardExtState, IContributionRewardExtProposalState, IProposalCreateOptionsCRExt> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query: DocumentNode): IContributionRewardExtState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsCRExt): Promise<ITransaction>;
    createProposalTransactionMap(): (receipt: ITransactionReceipt) => ContributionRewardExtProposal;
    ethBalance(): Promise<Observable<BN>>;
}
