import { DocumentNode } from 'graphql';
import { Address, Arc, IGenericSchemeProposalState, IGenesisProtocolParams, IPluginState, IProposalBaseCreateOptions, ITransaction, ProposalPlugin, transactionResultHandler } from '../../index';
export interface IGenericSchemeState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        contractToCall: Address;
        voteParams: IGenesisProtocolParams;
    };
}
export interface IProposalCreateOptionsGS extends IProposalBaseCreateOptions {
    callData?: string;
    value?: number;
}
export declare class GenericScheme extends ProposalPlugin<IGenericSchemeState, IGenericSchemeProposalState, IProposalCreateOptionsGS> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query: DocumentNode): IGenericSchemeState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsGS): Promise<ITransaction>;
    createProposalTransactionMap(): transactionResultHandler<any>;
}
