import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { Address, Arc, IApolloQueryOptions, IProposalState, Operation, Proposal } from '../../index';
export interface IGenericSchemeProposalState extends IProposalState {
    id: string;
    contractToCall: Address;
    callData: string;
    executed: boolean;
    returnValue: string;
}
export declare class GenericSchemeProposal extends Proposal<IGenericSchemeProposalState> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(context: Arc, item: any, query: DocumentNode): IGenericSchemeProposalState | null;
    private static fragmentField;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<IGenericSchemeProposalState>;
    redeemerContract(): import("ethers").Contract;
    redeemRewards(beneficiary?: Address): Operation<boolean>;
}
