import { DocumentNode } from 'graphql';
import { Address, Arc, IGenesisProtocolParams, IPluginState, IProposalBaseCreateOptions, ISchemeRegistrarProposalState, ITransaction, ITransactionReceipt, ProposalPlugin, SchemeRegistrarProposal } from '../../index';
export interface ISchemeRegistrarState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteRemoveParams: IGenesisProtocolParams;
        voteRegisterParams: IGenesisProtocolParams;
    };
}
export interface IProposalCreateOptionsSR extends IProposalBaseCreateOptions {
    proposalType: 'SchemeRegistrarAdd' | 'SchemeRegistrarEdit' | 'SchemeRegistrarRemove';
    parametersHash?: string;
    permissions?: string;
    schemeToRegister?: Address;
}
export declare class SchemeRegistrar extends ProposalPlugin<ISchemeRegistrarState, ISchemeRegistrarProposalState, IProposalCreateOptionsSR> {
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    static itemMap(arc: Arc, item: any, query: DocumentNode): ISchemeRegistrarState | null;
    private static fragmentField;
    createProposalTransaction(options: IProposalCreateOptionsSR): Promise<ITransaction>;
    createProposalTransactionMap(options: IProposalCreateOptionsSR): (receipt: ITransactionReceipt) => SchemeRegistrarProposal;
}
