import { DocumentNode } from 'graphql';
import { Observable } from 'rxjs';
import { Address, Arc, IApolloQueryOptions, IProposalState, Proposal } from '../../index';
export interface ISchemeRegistrarProposalState extends IProposalState {
    id: string;
    schemeToRegister: Address;
    schemeToRegisterPermission: string;
    schemeToRemove: string;
    decision: number;
    schemeRegistered: boolean;
    schemeRemoved: boolean;
}
export declare class SchemeRegistrarProposal extends Proposal<ISchemeRegistrarProposalState> {
    protected static fragmentField: {
        name: string;
        fragment: DocumentNode;
    } | undefined;
    static get fragment(): {
        name: string;
        fragment: DocumentNode;
    };
    protected static itemMap(context: Arc, item: any, query: DocumentNode): ISchemeRegistrarProposalState | null;
    state(apolloQueryOptions: IApolloQueryOptions): Observable<ISchemeRegistrarProposalState>;
}
