import { Competition, CompetitionProposal, ContributionReward, ContributionRewardExt, ContributionRewardExtProposal, ContributionRewardProposal, FundingRequest, FundingRequestProposal, GenericScheme, GenericSchemeProposal, IPluginState, IProposalBaseCreateOptions, IProposalCreateOptionsComp, IProposalCreateOptionsCR, IProposalCreateOptionsCRExt, IProposalCreateOptionsFundingRequest, IProposalCreateOptionsGS, IProposalCreateOptionsJoinAndQuit, IProposalCreateOptionsSR, IProposalState, JoinAndQuit, JoinAndQuitProposal, Plugin, Proposal, ProposalPlugin, ReputationFromToken, SchemeRegistrar, SchemeRegistrarProposal, UnknownPlugin } from '../index';
export declare const ProposalPlugins: {
    GenericScheme: typeof GenericScheme;
    SchemeRegistrar: typeof SchemeRegistrar;
    ContributionReward: typeof ContributionReward;
    ContributionRewardExt: typeof ContributionRewardExt;
    Competition: typeof Competition;
    FundingRequest: typeof FundingRequest;
    JoinAndQuit: typeof JoinAndQuit;
};
export declare const Plugins: {
    ReputationFromToken: typeof ReputationFromToken;
    unknown: typeof UnknownPlugin;
    GenericScheme: typeof GenericScheme;
    SchemeRegistrar: typeof SchemeRegistrar;
    ContributionReward: typeof ContributionReward;
    ContributionRewardExt: typeof ContributionRewardExt;
    Competition: typeof Competition;
    FundingRequest: typeof FundingRequest;
    JoinAndQuit: typeof JoinAndQuit;
};
export declare type PluginName = keyof typeof Plugins;
export declare const Proposals: {
    GenericScheme: typeof GenericSchemeProposal;
    ContributionReward: typeof ContributionRewardProposal;
    Competition: typeof CompetitionProposal;
    ContributionRewardExt: typeof ContributionRewardExtProposal;
    FundingRequest: typeof FundingRequestProposal;
    JoinAndQuit: typeof JoinAndQuitProposal;
    SchemeRegistrar: typeof SchemeRegistrarProposal;
    SchemeRegistrarAdd: typeof SchemeRegistrarProposal;
    SchemeRegistrarEdit: typeof SchemeRegistrarProposal;
    SchemeRegistrarRemove: typeof SchemeRegistrarProposal;
};
export declare type ProposalName = keyof typeof Proposals;
export declare type ProposalCreateOptions = IProposalCreateOptionsCRExt | IProposalCreateOptionsGS | IProposalCreateOptionsSR | IProposalCreateOptionsComp | IProposalCreateOptionsCR | IProposalCreateOptionsFundingRequest | IProposalCreateOptionsJoinAndQuit;
export declare type AnyProposal = Proposal<IProposalState>;
export declare type AnyPlugin = Plugin<IPluginState>;
export declare type AnyProposalPlugin = ProposalPlugin<IPluginState, IProposalState, IProposalBaseCreateOptions>;
